<template>
  <div class="role-management-container">
    <vab-query-form>
      <vab-query-form-left-panel :span="8">
        <el-button icon="el-icon-plus" type="primary" @click="handleEdit">
          {{ __('添加') }}
        </el-button>
      </vab-query-form-left-panel>
      <vab-query-form-right-panel :span="16">
        <el-form :inline="true" :model="queryForm" @submit.native.prevent>
          <el-form-item>
            <el-input
              v-model.trim="queryForm.rights_group_name"
              clearable
              :placeholder="__('请输入角色')"
            />
          </el-form-item>
          <el-form-item>
            <el-button icon="el-icon-search" type="primary" @click="queryData">
              {{ __('查询') }}
            </el-button>
          </el-form-item>
        </el-form>
      </vab-query-form-right-panel>
    </vab-query-form>

    <el-table
      v-loading="listLoading"
      border
      :data="list"
      :height="tableConfig.height"
      @selection-change="setSelectRows"
    >
      <el-table-column align="center" :label="__('序号')" width="55">
        <template #default="{ $index }">
          {{ $index + 1 }}
        </template>
      </el-table-column>

      <el-table-column
        align="center"
        :label="__('操作')"
        show-overflow-tooltip
        width="180"
      >
        <template #default="{ row }">
          <el-button
            type="text"
            @click="handleDistribution(row)"
          >
            设置权限
          </el-button>
          <el-button
            type="text"
            @click="handleEdit(row)"
          >
            编辑
          </el-button>
          <el-button
            type="text"
            @click="handleDelete(row)"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
      <el-table-column
        align="center"
        :label="__('编号')"
        prop="rights_group_id"
        show-overflow-tooltip
      />
      <el-table-column
        align="center"
        :label="__('权限组名称')"
        prop="rights_group_name"
        show-overflow-tooltip
      />
      <template #empty>
        <el-image
          class="vab-data-empty"
          :src="require('@/assets/empty_images/data_empty.png')"
        />
      </template>
    </el-table>
    <el-pagination
      background
      :current-page="queryForm.pageNum"
      :layout="layout"
      :page-size="queryForm.pageSize"
      :total="total"
      @current-change="handleCurrentChange"
      @size-change="handleSizeChange"
    />
    <edit ref="edit" @fetch-data="fetchData" />
    <Distribution ref="distribution" @fetch-data="fetchData" />
  </div>
</template>

<script>
  import { doDelete, getList } from '@/api/rights/group'
  import Edit from './components/RoleManagementEdit'
  import Distribution from './components/RoleDistribution'
  import { translateTitle as __ } from '@/utils/i18n'

  export default {
    name: 'RoleManagement',
    // eslint-disable-next-line vue/no-unused-components
    components: { Edit, Distribution },
    data() {
      return {
        tableConfig: {
          height: window.innerHeight - 220 - 90,
        },
        list: [],
        listLoading: true,
        layout: 'total, sizes, prev, pager, next, jumper',
        total: 0,
        selectRows: '',
        queryForm: {
          pageNum: 1,
          pageSize: 20,
          rights_group_name: '',
        },
      }
    },
    created() {
      this.fetchData()
    },
    methods: {
      __,
      setSelectRows(val) {
        this.selectRows = val
      },
      handleEdit(row) {
        if (row.rights_group_id) {
          this.$refs['edit'].showEdit(row)
        } else {
          this.$refs['edit'].showEdit()
        }
      },
      handleDistribution(row) {
        if (row.rights_group_id) {
          this.$refs['distribution'].showDistribution(row)
        }
      },
      handleDelete(row) {
        if (row.rights_group_id) {
          this.$baseConfirm(this.__('你确定要删除当前项吗'), null, async () => {
            const { msg, status } = await doDelete({
              rights_group_ids: row.rights_group_id,
            })
            this.$baseMessage(msg, 'success', false, 'vab-hey-messa-success')
            await this.fetchData()
          })
        } else {
          if (this.selectRows.length > 0) {
            const rights_group_ids = this.selectRows
              .map((item) => item.rights_group_id)
              .join()
            this.$baseConfirm(
              this.__('你确定要删除选中项吗'),
              null,
              async () => {
                const { msg, status } = await doDelete({
                  rights_group_ids: rights_group_ids,
                })
                this.$baseMessage(msg, 'success', false, 'vab-hey-msg-success')
                await this.fetchData()
              }
            )
          } else {
            this.$baseMessage(
              this.__('未选中任何行'),
              'error',
              false,
              'vab-hey-msg-error'
            )
            return false
          }
        }
      },
      handleSizeChange(val) {
        this.queryForm.pageSize = val
        this.fetchData()
      },
      handleCurrentChange(val) {
        this.queryForm.pageNum = val
        this.fetchData()
      },
      queryData() {
        this.queryForm.pageNum = 1
        this.fetchData()
      },
      async fetchData() {
        this.listLoading = true
        const { data } = await getList(this.queryForm)
        this.list = data.items
        this.total = data.records
        this.listLoading = false
      },
    },
  }
</script>
